/* p80211ioctl.h: Declares constants and types for the p80211 ioctls
* --------------------------------------------------------------------
*
* Linux WLAN 
*
* The contents of this file are subject to the Mozilla Public
* License Version 1.0 (the "License"); you may not use this file
* except in compliance with the License. You may obtain a copy of
* the License at http://www.mozilla.org/MPL/
*
* Software distributed under the License is distributed on an "AS
* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
* implied. See the License for the specific language governing
* rights and limitations under the License.
*
* The initial developer of the original code is Mark S. Mathews
* <mark@absoval.com>.  Portions created by Mark S. Mathews
* are Copyright (C) 1998 AbsoluteValue Software, Inc.  All Rights Reserved.
*   
* --------------------------------------------------------------------
*
* The initial author may be reached as mark@absoval.com, or 
* C/O AbsoluteValue Software Inc., P.O. Box 941149, 
* Maitland, FL, 32794-1149
*
* --------------------------------------------------------------------
*
* --------------------------------------------------------------------
*/


#ifndef _P80211IOCTL_H
#define _P80211IOCTL_H

/*================================================================*/
/* Constants */

/*----------------------------------------------------------------*/
/* p80211 ioctl "request" codes.  See argument 2 of ioctl(2). */

#define P80211_IFTEST		(SIOCDEVPRIVATE + 0)
#define P80211_IFREQ		(SIOCDEVPRIVATE + 1)

/*----------------------------------------------------------------*/
/* Magic number, a quick test to see we're getting the desired struct */

#define P80211_IOCTL_MAGIC	(0x4a2d464dUL)

/*----------------------------------------------------------------*/
/* Netlink protocol numbers for indication and sniffing  */

#define P80211_NL_SOCK_IND	NETLINK_USERSOCK
#define P80211_NL_SOCK_SNIF	NETLINK_USERSOCK+1

/*================================================================*/
/* Macros */


/*================================================================*/
/* Types */

/*----------------------------------------------------------------*/
/* A ptr to the following structure type is passed as the third */
/*  argument to the ioctl system call when issuing a request to */
/*  the p80211 module. */

typedef struct p80211ioctl_req
{
	char 	name[WLAN_DEVNAMELEN_MAX]	__WLAN_ATTRIB_PACK__;
	void	*data				__WLAN_ATTRIB_PACK__;
	UINT32	magic				__WLAN_ATTRIB_PACK__;
	UINT16	len				__WLAN_ATTRIB_PACK__;
	UINT32	result				__WLAN_ATTRIB_PACK__;
} p80211ioctl_req_t;


/*================================================================*/
/* Extern Declarations */


/*================================================================*/
/* Function Declarations */


#endif /* _P80211IOCTL_H */
