/* p80211msg.h: Macros, constants, types, and funcs for req and ind messages
* --------------------------------------------------------------------
* Linux WLAN 
*
* The contents of this file are subject to the Mozilla Public
* License Version 1.0 (the "License"); you may not use this file
* except in compliance with the License. You may obtain a copy of
* the License at http://www.mozilla.org/MPL/
*
* Software distributed under the License is distributed on an "AS
* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
* implied. See the License for the specific language governing
* rights and limitations under the License.
*
* The initial developers of the original code are Jo-Ellen F. Mathews
* <joellen@absoval.com> and Mark S. Mathews <mark@absoval.com>.  
* Portions created by Jo-Ellen F. and Mark S. Mathews
* are Copyright (C) 1998 AbsoluteValue Software, Inc.  All Rights Reserved.
*   
* --------------------------------------------------------------------
*
* The initial authors may be reached at info@absoval.com, or 
* C/O AbsoluteValue Software Inc., P.O. Box 941149, 
* Maitland, FL, 32794-1149
*
* --------------------------------------------------------------------
*
* --------------------------------------------------------------------
*/

#ifndef _P80211MSG_H
#define _P80211MSG_H

/*================================================================*/
/* System Includes */

/*================================================================*/
/* Project Includes */

#ifndef _WLAN_COMPAT_H
#include <wlan/wlan_compat.h>
#endif

/*================================================================*/
/* Constants */

#define MSG_BUFF_LEN		4000
#define WLAN_DEVNAMELEN_MAX	16

/*================================================================*/
/* Macros */

/*================================================================*/
/* Types */

/*--------------------------------------------------------------------*/
/*----- Message Structure Types --------------------------------------*/

/*--------------------------------------------------------------------*/
/* Prototype msg type */

__WLAN_PRAGMA_PACK1__
typedef struct p80211msg
{
	UINT32	msgcode				__WLAN_ATTRIB_PACK__;
	UINT32	msglen				__WLAN_ATTRIB_PACK__;
	UINT8	devname[WLAN_DEVNAMELEN_MAX]	__WLAN_ATTRIB_PACK__;
} p80211msg_t;
__WLAN_PRAGMA_PACKDFLT__


__WLAN_PRAGMA_PACK1__
typedef struct p80211msgd
{
	UINT32	msgcode				__WLAN_ATTRIB_PACK__;
	UINT32	msglen				__WLAN_ATTRIB_PACK__;
	UINT8	devname[WLAN_DEVNAMELEN_MAX]	__WLAN_ATTRIB_PACK__;
	UINT8	args[0]				__WLAN_ATTRIB_PACK__;
} p80211msgd_t;
__WLAN_PRAGMA_PACKDFLT__

/*================================================================*/
/* Extern Declarations */


/*================================================================*/
/* Function Declarations */

UINT32 p80211item_getoffset( struct catlistitem *metalist, UINT32 did );

#endif  /* _P80211MSG_H */

