/* p80211 program to build the message structures and typedefs
* --------------------------------------------------------------------
*
* Linux WLAN 
*
* The contents of this file are subject to the Mozilla Public
* License Version 1.0 (the "License"); you may not use this file
* except in compliance with the License. You may obtain a copy of
* the License at http://www.mozilla.org/MPL/
*
* Software distributed under the License is distributed on an "AS
* IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
* implied. See the License for the specific language governing
* rights and limitations under the License.
*
* The initial developer of the original code is Mark S. Mathews
* <mark@absoval.com>.  Portions created by Mark S. Mathews
* are Copyright (C) 1998 AbsoluteValue Software, Inc.  All Rights Reserved.
*   
* --------------------------------------------------------------------
*
* The initial author may be reached as mark@absoval.com, or 
* C/O AbsoluteValue Software Inc., P.O. Box 941149, 
* Maitland, FL, 32794-1149
*
* --------------------------------------------------------------------
* The purpose of this program is to generate a header file containing
* all the structures and typedefs for all message metadata category
* names, group names and data item names.
--------------------------------------------------------------------*/

#include <stdlib.h>
#include <stdio.h>
#include <wlan/wlan_compat.h>
#include <wlan/p80211types.h>
#include <wlan/p80211meta.h>
#include <wlan/p80211metamsg.h>
#include <wlan/p80211metamib.h>

int main(int argc, char **argv)
{
    int     c, g, i, totgrps, totitems, type;
    char    name[4][82];

/* traverse the message metadata to build the structures and typedefs */
    for ( c = 1; c < msg_catlist_size; c++ )
    {
        totgrps = GETMETASIZE(msg_catlist[c].grplist);
        for ( g = 1; g < totgrps; g++ )
        {
	    switch (c)
	    {
	        case 1: strcpy(name[c], "p80211msg_req_");
	            break;
	        case 2: strcpy(name[c], "p80211msg_ind_");
	            break;
	        case 3: strcpy(name[c], "p80211msg_cfm_");
	            break;
	        default:
	            break;
	    }
            printf("__WLAN_PRAGMA_PACK1__\n");
            printf("typedef struct %s%s\n{\n", name[c],
                msg_catlist[c].grplist[g].name);
            printf("\tUINT32\t\tmsgcode\t__WLAN_ATTRIB_PACK__;\n");
            printf("\tUINT32\t\tmsglen\t__WLAN_ATTRIB_PACK__;\n");
            printf("\tUINT8\t\tdevname[WLAN_DEVNAMELEN_MAX]\t__WLAN_ATTRIB_PACK__;\n");
            totitems = GETMETASIZE(msg_catlist[c].grplist[g].itemlist);
            for ( i = 1; i < totitems; i++ )
            {
                type = P80211DID_TYPE(
                            msg_catlist[c].grplist[g].itemlist[i].did);
		switch ( type )
		{
                    case P80211_TYPE_BOUNDEDINT:
                    case P80211_TYPE_INT:
                    case P80211_TYPE_ENUMINT:
                         printf("\tp80211item_uint32_t");
                         printf("\t%s\t__WLAN_ATTRIB_PACK__;\n",
                             msg_catlist[c].grplist[g].itemlist[i].name);
	                break;
		    case P80211_TYPE_UNKDATA:
		        printf("\tp80211item_unk%d_t",
                            msg_catlist[c].grplist[g].itemlist[i].maxlen);
                        printf("\t%s\t__WLAN_ATTRIB_PACK__;\n",
                            msg_catlist[c].grplist[g].itemlist[i].name);
			break;
	            default:
                         printf("\tp80211item_pstr%ld_t",
                            msg_catlist[c].grplist[g].itemlist[i].maxlen);
                         printf("\t%s\t__WLAN_ATTRIB_PACK__;\n",
                             msg_catlist[c].grplist[g].itemlist[i].name);
	                break;
		}
            }
            printf("} %s%s_t;\n__WLAN_PRAGMA_PACKDFLT__\n\n\n", name[c],
                msg_catlist[c].grplist[g].name);
        }
    }

    return 0;
}
