/* prism2mgmt.h: Declares the mgmt command handler functions
*    --------------------------------------------------------------------
*
*   Linux WLAN 
*
*   The contents of this file are subject to the Mozilla Public
*   License Version 1.0 (the "License"); you may not use this file
*   except in compliance with the License. You may obtain a copy of
*   the License at http://www.mozilla.org/MPL/
*
*   Software distributed under the License is distributed on an "AS
*   IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
*   implied. See the License for the specific language governing
*   rights and limitations under the License.
*
*   The initial developer of the original code is Mark S. Mathews
*   <mark@absoval.com>.  Portions created by Mark S. Mathews
*   are Copyright (C) 1998 AbsoluteValue Software, Inc.  All
*   Rights Reserved. 
*
*	This software was developed by AbsoluteValue Software, Inc. under
*	contract to Harris Semiconductor.  
*
*   [Change History]
*	990715 - Initial Creation <mark@absoval.com>
*
*	This file contains the constants and data structures for interaction
*	with the hfa384x Wireless LAN (WLAN) Media Access Contoller (MAC).  
*	The hfa384x is a portion of the Harris PRISM(tm) WLAN chipset.
*
*   [Implementation and usage notes]
*
*   [References]
*	CW10 Programmer's Manual v1.5
*	IEEE 802.11 D10.0
*
*    --------------------------------------------------------------------
*/

#ifndef _PRISM2MGMT_H
#define _PRISM2MGMT_H

/*=============================================================*/
/*------ Constants --------------------------------------------*/


/*=============================================================*/
/*------ Macros -----------------------------------------------*/


/*=============================================================*/
/*------ Types and their related constants --------------------*/

typedef struct prism2sta_priv
{
	dev_node_t	node;

	/* Structure for MAC data */
	hfa384x_t	*hw;

	/* MAC buffer ids */
	UINT16		txfid;
	UINT16		infofid;
} prism2sta_priv_t;


/*=============================================================*/
/*------ Static variable externs ------------------------------*/

extern int	prism2_debug;

/*=============================================================*/
/*--- Function Declarations -----------------------------------*/
/*=============================================================*/

int prism2mgmt_mibget(wlandevice_t *wlandev, void *msgp);
int prism2mgmt_mibset(wlandevice_t *wlandev, void *msgp);
int prism2mgmt_powermgmt(wlandevice_t *wlandev, void *msgp);
int prism2mgmt_scan(wlandevice_t *wlandev, void *msgp);
int prism2mgmt_scan_results(wlandevice_t *wlandev, void *msgp);
int prism2mgmt_join(wlandevice_t *wlandev, void *msgp);
int prism2mgmt_authenticate(wlandevice_t *wlandev, void *msgp);
int prism2mgmt_deauthenticate(wlandevice_t *wlandev, void *msgp);
int prism2mgmt_associate(wlandevice_t *wlandev, void *msgp);
int prism2mgmt_reassociate(wlandevice_t *wlandev, void *msgp);
int prism2mgmt_disassociate(wlandevice_t *wlandev, void *msgp);
int prism2mgmt_start(wlandevice_t *wlandev, void *msgp);


/*=============================================================*/
/*--- Inline Function Definitions (if supported) --------------*/
/*=============================================================*/



#endif
